/*
         PRINTIT.PRG
*/

#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#INCLUDE "font.ch"
#include "XBPDEV.CH"

#define SPACECHR  "L"
#define LINESPACING 5
#define WFACTOR 1
#define HFACTOR 0.82
STATIC oCurrFont
STATIC oCurrRefFont
STATIC oCurroPS 
STATIC aLastPos
STATIC PrnAdjust := 0 
STATIC SegPage
STATIC oPreview
STATIC oDlgPreview 
STATIC aPaperSize 
STATIC RtnScreen

FUNCTION SetFont(oFont)
   oCurrFont := oFont
RETURN NIL
   
FUNCTION SetReference(oFont)
   oCurrRefFont := oFont
RETURN NIL

FUNCTION SetoPS(oPS)
   oCurroPS := oPS
RETURN NIL
                
FUNCTION SetAdjust()
LOCAL cText
   IF PrnAdjust = 0 .AND. FILE("c:\winfid\PRNADJUST.TXT")
      cText := MEMOREAD("c:\winfid\PRNADJUST.TXT")
      PrnAdjust := VAL(Alltrim(cText))
   ENDIF
RETURN NIL

FUNCTION PrnVar(aPos,cVar,oPS,oFont,oRefFont) // note aPos is in Y,X order to ease mod of @say syntex
LOCAL aTopRight,a_size, aPrint,aSize2

      SetAdjust()
      IF oFont = NIL
         oFont := oCurrFont
      ELSE
         oCurrFont := oFont        
      ENDIF
      
      IF oRefFont = NIL
         oRefFont := oCurrRefFont
      ELSE
         oCurrRefFont := oRefFont        
      ENDIF
      IF oPS = NIL
         oPS := oCurroPS
      ELSE
         oCurroPS := oPS   
      ENDIF
      IF oRefFont = NIL .OR. oFont = NIL .OR. oPS = NIL
         MSGBOX("ERROR no defined font in printit! "+STR(aPos[1],3)+','+STR(aPos[2],3))
         RETURN NIL
      ENDIF
      DO CASE
        CASE VALTYPE(cVar)=="N"
          cVar := STR(cVar)
        CASE VALTYPE(cVar)=="D"
          cVar := DTOC(cVar)
        CASE VALTYPE(cVar)=="C"
        CASE VALTYPE(cVar)=="L"
          IF cVar
             cVar := "Y"
          ELSE
             cVar := "N"
          ENDIF
        OTHERWISE
          MSGBOX("ERROR incorrect data type in printit! "+STR(aPos[1],3)+','+STR(aPos[2],3))
      ENDCASE
      GraSetFont(oPS , oRefFont )                // reference font for spacing
      IF !oRefFont:Fixed
         a_Size := GraQueryTextBox( oPS, SPACECHR )  //spaceing based on 'L'
      ELSE
         a_Size := {oRefFont:Width * WFACTOR,oRefFont:Height * HFACTOR}
      ENDIF
      GraSetFont(oPS , oFont )                // Select font 

      aTopRight :={aPaperSize[1]-(aPaperSize[3]+(aPaperSize[1]-aPaperSize[5])),aPaperSize[2] - (aPaperSize[4]+(aPaperSize[2]-aPaperSize[6]))} 
      IF !oRefFont:Fixed
         aPrint := {aPos[2]*a_Size[3,1],aTopRight[2]-(aPos[1]*(a_Size[1,2]+LINESPACING+PrnAdjust))}
      ELSE
         aPrint := {aPos[2]*a_Size[1],aTopRight[2]-(aPos[1]*(a_Size[2]+PrnAdjust))}
      ENDIF
          // Print string  
      GraStringAt( oPS, aPrint, cVar ) 
      oCurrRefFont := oRefFont        
      oCurrFont := oFont        

RETURN NIL

FUNCTION PrnMemo(aPos,cVar,oPS,oFont,nWidth) // note aPos is in Y,X order to ease mod of @say syntex
LOCAL aTopRight,a_size,a_size2, aPrint,aSize2,nline:= 0,TotLine,cLine,oRefFont

      SetAdjust()
      IF oFont = NIL
         oFont := oCurrFont
      ELSE
         oCurrFont := oFont        
      ENDIF
      
      oRefFont := oCurrRefFont
      IF oRefFont = NIL .OR. oFont = NIL
         MSGBOX("ERROR no defined font in printit! "+STR(aPos[1],3)+','+STR(aPos[2],3))
         RETURN NIL
      ENDIF
      DO CASE
        CASE VALTYPE(cVar)=="N"
          cVar := STR(cVar)
        CASE VALTYPE(cVar)=="D"
          cVar := DTOC(cVar)
        CASE VALTYPE(cVar)=="C"
        CASE VALTYPE(cVar)=="L"
          IF cVar
             cVar := "Y"
          ELSE
             cVar := "N"
          ENDIF
        OTHERWISE
          MSGBOX("ERROR incorrect data type in printit! "+STR(aPos[1],3)+','+STR(aPos[2],3))
      ENDCASE
      GraSetFont(oPS , oRefFont )                // reference font for spacing

      IF !oRefFont:Fixed
         a_Size := GraQueryTextBox( oPS, SPACECHR )  //spaceing based on 'L'
      ELSE
         a_Size := {oRefFont:Width * WFACTOR,oRefFont:Height * HFACTOR}
      ENDIF


      GraSetFont(oPS , oFont )                // Select font 
      a_Size2 := GraQueryTextBox( oPS, SPACECHR )  

      TotLine := MLCOUNT(cVar,nWidth)
      aTopRight :={aPaperSize[1]-(aPaperSize[3]+(aPaperSize[1]-aPaperSize[5])),aPaperSize[2] - (aPaperSize[4]+(aPaperSize[2]-aPaperSize[6]))} 
      DO WHILE nLine < TotLine
         IF !oRefFont:Fixed
            aPrint := {aPos[2]*a_Size[3,1],aTopRight[2]-(aPos[1]*(a_Size[1,2]+LINESPACING+PrnAdjust))-nLine*a_Size2[1,2]}
         ELSE
            aPrint := {aPos[2]*a_Size[1],aTopRight[2]-(aPos[1]*(a_Size[2]+LINESPACING+PrnAdjust))-nLine*a_Size2[2]}
         ENDIF   
         // Print string  
         cLine := MemoLine(cVar,nWidth,nLine+1)
         GraStringAt( oPS, aPrint, cLine ) 
         ++nLine
      ENDDO   

RETURN nLine+aPos[1]+1

FUNCTION PrVLine(aFrom,aTo,oPs,oRefFont)
LOCAL aTopRight,a_size, aPosFrom,aPosTo,aSize2
      
      SetAdjust()
      IF oPS = NIL
         oPS := oCurroPS
      ELSE
         oCurroPS := oPS   
      ENDIF
      IF oRefFont = NIL
         oRefFont := oCurrRefFont
      ELSE
         oCurrRefFont := oRefFont        
      ENDIF
      GraSetFont(oPS , oRefFont )                // reference font for spacing

      IF !oRefFont:Fixed
         a_Size := GraQueryTextBox( oPS, SPACECHR )  //spaceing based on 'L'
      ELSE
         a_Size := {oRefFont:Width * WFACTOR,oRefFont:Height * HFACTOR}
      ENDIF

      aTopRight :={aPaperSize[1]-(aPaperSize[3]+(aPaperSize[1]-aPaperSize[5])),aPaperSize[2] - (aPaperSize[4]+(aPaperSize[2]-aPaperSize[6]))} 
      IF !oRefFont:Fixed
         aPosFrom := {aFrom[2]*a_Size[3,1],aTopRight[2]-(aFrom[1]*(a_Size[1,2]+LINESPACING+PrnAdjust))}
         aPosTo := {aTo[2]*a_Size[3,1],aTopRight[2]-(aTo[1]*(a_Size[1,2]+LINESPACING+PrnAdjust))}
      ELSE
         aPosFrom := {aFrom[2]*a_Size[1],aTopRight[2]-(aFrom[1]*(a_Size[2]+PrnAdjust))}
         aPosTo := {aTo[2]*a_Size[1],aTopRight[2]-(aTo[1]*(a_Size[2]+PrnAdjust))}
      ENDIF   
      GRaLine( oPS,aPosFrom,aPosTo) 
      ++aPosFrom[1]
      ++aPosTo[1]
      GRaLine( oPS,aPosFrom,aPosTo) 
RETURN NIL

FUNCTION PrnVarCenter(nPos,cVar,oPS,oFont,oRefFont) 
LOCAL aTopRight,a_size, aPrint,Size2

      SetAdjust()
      IF oFont = NIL
         oFont := oCurrFont
      ELSE
         oCurrFont := oFont        
      ENDIF
      
      IF oRefFont = NIL
         oRefFont := oCurrRefFont
      ELSE
         oCurrRefFont := oRefFont        
      ENDIF
      IF oPS = NIL
         oPS := oCurroPS
      ELSE
         oCurroPS := oPS   
      ENDIF
      IF oRefFont = NIL .OR. oFont = NIL .OR. oPS = NIL
         MSGBOX("ERROR no defined font in printit! Center"+STR(nPos,3))
         RETURN NIL
      ENDIF
      DO CASE
        CASE VALTYPE(cVar)=="N"
          cVar := STR(cVar)
        CASE VALTYPE(cVar)=="D"
          cVar := DTOC(cVar)
        CASE VALTYPE(cVar)=="C"
        CASE VALTYPE(cVar)=="L"
          IF cVar
             cVar := "Y"
          ELSE
             cVar := "N"
          ENDIF
        OTHERWISE
          MSGBOX("ERROR incorrect data type in printit Center! "+STR(nPos,3))
      ENDCASE
      GraSetFont(oPS , oRefFont )                // reference font for spacing

      IF !oRefFont:Fixed
         a_Size := GraQueryTextBox( oPS, SPACECHR )  //spaceing based on 'L'
      ELSE
         a_Size := {oRefFont:Width * WFACTOR,oRefFont:Height * HFACTOR}
      ENDIF
      GraSetFont(oPS , oFont )                // Select font 
      Size2 := FontHMetric(cVar,oFont)

      aTopRight :={aPaperSize[1]-(aPaperSize[3]+(aPaperSize[1]-aPaperSize[5])),aPaperSize[2] - (aPaperSize[4]+(aPaperSize[2]-aPaperSize[6]))} 
      IF !oRefFont:Fixed
         aPrint := {(aTopRight[1]-Size2*a_Size[3,1])/2,aTopRight[2]-(nPos*(a_Size[1,2]+LINESPACING+PrnAdjust))}
      ELSE
         aPrint := {(aTopRight[1]-Size2*a_Size[1])/2,aTopRight[2]-(nPos*(a_Size[2]+PrnAdjust))}
      ENDIF   
          // Print string  
      GraStringAt( oPS, aPrint, cVar ) 
      oCurrRefFont := oRefFont        
      oCurrFont := oFont        

RETURN NIL

FUNCTION PrnPic(cFile,aPos,aTargSize,oPS)
LOCAL oBitmap,aRect,a_Size,aTopRight,lTest
      IF oPS = NIL
         oPS := oCurroPS
      ELSE
         oCurroPS := oPS   
      ENDIF
      IF !oRefFont:Fixed
         a_Size := GraQueryTextBox( oPS, SPACECHR )  //spaceing based on 'L'
      ELSE
         a_Size := {oRefFont:Width * WFACTOR,oRefFont:Height * HFACTOR}
      ENDIF
      aTopRight :={aPaperSize[1]-(aPaperSize[3]+(aPaperSize[1]-aPaperSize[5])),aPaperSize[2] - (aPaperSize[4]+(aPaperSize[2]-aPaperSize[6]))} 
      
      oBitmap    := XbpBitmap():new():create( oPS ) 
      IF !oRefFont:Fixed
         aRect      := { aPos[2]*a_Size[3,1], aTopRight[2]-aPos[1]*(a_Size[1,2]+LINESPACING+PrnAdjust), aPos[2]*a_Size[3,1]+aTargSize[1], aTopRight[2]-aPos[1]*(a_Size[1,2]+LINESPACING+PrnAdjust)+aTargSize[2] } 
      ELSE
         aRect      := { aPos[2]*a_Size[1], aTopRight[2]-aPos[1]*(a_Size[2]+PrnAdjust), aPos[2]*a_Size[1]+aTargSize[1], aTopRight[2]-aPos[1]*(a_Size[2]+LINESPACING+PrnAdjust)+aTargSize[2] } 
      ENDIF   
      oBitmap:loadFile( cFile )          // Load bitmap 
      lTest := oBitmap:draw( oPS, aRect )  // Spool print job 
      oBitmap:destroy() 
RETURN NIL

FUNCTION PrnBOX(aPos,aBoxSize,nThickness,oPS,oRefFont) //aBoxSize and aPos in refernce spacing 
LOCAL I,aLeftBottom,aRightTop,a_Size,aTopPage
      SetAdjust()
      IF Valtype(nThickness) != "N"
         nThickness = 1
      ENDIF 
      IF oPS = NIL
         oPS := oCurroPS
      ELSE
         oCurroPS := oPS   
      ENDIF
      IF oRefFont = NIL
         oRefFont := oCurrRefFont
      ELSE
         oCurrRefFont := oRefFont        
      ENDIF
      IF oRefFont = NIL .OR. oPS = NIL
         MSGBOX("ERROR no defined font in printit BOX! "+STR(nPos,3))
         RETURN NIL
      ENDIF  
      GraSetFont(oPS , oRefFont )                // reference font for spacing

      IF !oRefFont:Fixed
         a_Size := GraQueryTextBox( oPS, SPACECHR )  //spaceing based on 'L'
      ELSE
         a_Size := {oRefFont:Width * WFACTOR,oRefFont:Height * HFACTOR}
      ENDIF
      aTopPage :={aPaperSize[1]-(aPaperSize[3]+(aPaperSize[1]-aPaperSize[5])),aPaperSize[2] - (aPaperSize[4]+(aPaperSize[2]-aPaperSize[6]))} 
      IF !oRefFont:Fixed
         aLeftBottom := {aPos[2]*a_Size[3,1],aTopPage[2]-(aPos[1]*(a_Size[1,2]+LINESPACING+PrnAdjust))} // remember X,Y reversed in aPos for Clipper compat
         aRightTop := {aLeftBottom[1]+a_Size[3,1]*aBoxSize[2],aLeftBottom[2]+a_Size[3,2]*aBoxSize[1]}
      ELSE
         aLeftBottom := {aPos[2]*a_Size[1],aTopPage[2]-(aPos[1]*(a_Size[2]+PrnAdjust))} // remember X,Y reversed in aPos for Clipper compat
         aRightTop := {aLeftBottom[1]+a_Size[1]*aBoxSize[2],aLeftBottom[2]+a_Size[2]*aBoxSize[1]}
      ENDIF
      FOR I = 1 TO nThickness
         GraBox(oPS,aLeftBottom,aRightTop)
         ++aLeftBottom[1]
         ++aLeftBottom[2]
         --aRightTop[1]
         --aRightTop[2]
      NEXT I
RETURN NIL

FUNCTION PrnDataBOX(aPos,aBoxSize,cPrompt,cData,nThickness,oPS,oFontPrompt,oFont,oRefFont) //aBoxSize and aPos in refernce spacing 
LOCAL aRtn
   // Draw the box
   PrnBOX(aPos,aBoxSize,nThickness,oPS,oRefFont)
   PrnVar({aPos[1]-aBoxSize[1]+1 ,aPos[2]+1},cPrompt,oPS,oFontPrompt,oRefFont)
   PrnVar({aPos[1] ,aPos[2]+1},Alltrim(cData),oPS,oFont,oRefFont)
      
RETURN NIL  // number of refernce spacing used (Y,X) format


FUNCTION FontHMetric(cStr,oFont) // return graphic length ratio of str to SPACECHR
STATIC oRefFont,nRtn,a_Size,prevStr:=""
LOCAL oPS,a_Size2
   IF cStr = NIL
      RETURN 0
   ENDIF
   IF PrevStr == cStr
      RETURN nRtn
   ELSE
      prevStr := cStr
   ENDIF      
   IF EMPTY(oRefFont)
      oRefFont := oCurrRefFont      
   ENDIF
   oPS := oCurroPS 
   IF empty(a_Size) .OR. oRefFont != oCurrRefFont
      oRefFont := oCurrRefFont      
      GraSetFont(oPS , oRefFont )                // reference font for spacing 
      a_Size  := GraQueryTextBox( oPS, SPACECHR )  //spaceing based on 'L'
   ENDIF
   GraSetFont(oPs , oFont )
   a_Size2 := GraQueryTextBox( oPS, cStr )  //spaceing based on 'cStr'
   nRtn := a_Size2[3,1]/a_Size[3,1]    //ratio
   GraSetFont(oPS , oCurrFont )
RETURN nRtn

FUNCTION FontVMetric(cStr,oFont) // return graphic length ratio of str to SPACECHR
LOCAL nRtn,oRefFont,oPS,a_Size,a_Size2
   IF cStr = NIL
      RETURN 0
   ENDIF 
   oRefFont := oCurrRefFont      
   oPS := oCurroPS 
   GraSetFont(oPS , oRefFont )                // reference font for spacing 
   a_Size  := GraQueryTextBox( oPS, SPACECHR )  //spaceing based on 'L'
   GraSetFont(oPs , oFont )
   a_Size2 := GraQueryTextBox( oPS, cStr )  //spaceing based on 'cStr'
   nRtn := a_Size2[3,2]/a_Size[3,2]    //ratio
   GraSetFont(oPS , oCurrFont )
RETURN nRtn

FUNCTION PrinterPS( cPrinterObjectName,cIsLabel ) 
      LOCAL oPS, oDC := XbpPrinter():New() 
 
      oDC:Create( cPrinterObjectName )
      IF cIslabel = "Label"
         IF oDC:SetFormSize(XBPPRN_FORM_USER) = NIL
            
         ENDIF
      ENDIF   
          
      oPS := XbpPresSpace():New() 
      oPS:Create( oDC, oDC:paperSize(), GRA_PU_LOMETRIC ) 
RETURN oPS 
 
PROCEDURE DestroyDevice( oPS ) 
      LOCAL oDC := oPS:device() 
 
      IF oDC <> NIL 
         oPS:configure() 
         oDC:destroy() 
      ENDIF 
RETURN 

FUNCTION StartPrinter(cfont,nSize,cPrinterObjectName,cIsLabel,lPreview,o)
LOCAL oPS, oPrinter,aPageSize,I
     // PRINT FUNCTION  
     IF lPreview = NIL
        lPreview := .F.
     ENDIF   
     IF cPrinterObjectName = NIL
        oDlg := XbpPrintDialog():new() 
        oDlg:create() 
        oPrinter := oDlg:display() 
        oDlg:destroy() 
        IF oPrinter = NIL
           MsgBox("Printing aborted!")
           Return {} 
        ENDIF    
        DO WHILE ActiveReports > 0
           SLEEP(100)
        ENDDO
        oPS := XbpPresSpace():New() 
        aPaperSize  := oPrinter:paperSize()
        IF !lPreview
           oPS:Create( oPrinter, oPrinter:paperSize(), GRA_PU_LOMETRIC ) 
        ELSE
           oPS:mode := XBPPS_MODE_HIGH_PRECISION
           aPageSize := { aPaperSize[5]-aPaperSize[3], aPaperSize[6]-aPaperSize[4] }
         // Link presentation space with printer device context
         // The PS is created with the metric unit 1/10 mm
           oPS:create( oPrinter, aPageSize, GRA_PU_LOMETRIC )
        ENDIF
     ELSE 
        oPS := PrinterPS(ALLTRIM(cPrinterObjectName),cIsLabel) 
     ENDIF
     oFont := XbpFont():new(oPS)              // Create XbpFont object 
 
     oFont:familyName := cFont // Describe font 
     oFont:nominalPointSize := nSize
     oFont:generic := .T.
     oFont:create()                          // Create font 
     // Activate spooling 
     IF lPreview
        oPreview := XbpPreview():New()
        oPreview:oPresSpace := oPS 
        oPreview:Printer := oPrinter
        // Start first page
        oPreview:nPage := 1 
        oDlgPreview := Preview(o,oPreview)
        oDlgPreview:DrawingArea:SetPointer(,XBPSTATIC_SYSICON_WAIT,XBPWINDOW_POINTERTYPE_SYSPOINTER)
        FOR I = 1 TO LEN(oDlgPreview:DrawingArea:ChildList())
           oDlgPreview:DrawingArea:ChildList()[I]:SetPointer(,XBPSTATIC_SYSICON_WAIT,XBPWINDOW_POINTERTYPE_SYSPOINTER)
           IF oDlgPreview:DrawingArea:ChildList()[I]:IsDerivedfrom("XbpPreview")
              oDlgPreview:DrawingArea:ChildList()[I]:SetPointer(,XBPSTATIC_SYSICON_WAIT,XBPWINDOW_POINTERTYPE_SYSPOINTER)
              oDlgPreview:DrawingArea:ChildList()[I]:oView:DrawingArea:SetPointer(,XBPSTATIC_SYSICON_WAIT,XBPWINDOW_POINTERTYPE_SYSPOINTER)
              FOR J = 1 TO LEN(oDlgPreview:DrawingArea:ChildList()[I]:ChildList())
                 oDlgPreview:DrawingArea:ChildList()[I]:ChildList()[J]:SetPointer(,XBPSTATIC_SYSICON_WAIT,XBPWINDOW_POINTERTYPE_SYSPOINTER)
              NEXT J
           ENDIF
        NEXT I
        GraSegDrawMode( oPS, GRA_DM_RETAIN )
        AADD(oPreview:segments,GraSegOpen( oPS )) 
        RtnScreen := o
     ELSE
        oPS:device():startDoc()
     ENDIF  
     oCurroPS := oPS  
     ++ActiveReports
RETURN {oPS,oFont}

FUNCTION Printer_EJECT(oPs)
   IF oPS = NIL
      oPS := oCurroPS
   ENDIF
   IF EMPTY(oPreview)
      oPS:device():NewPage()
   ELSE
      GraSegClose( oPS )
      //Render current 
      oPreview:drawPage()
      //Start new page
      AADD(oPreview:segments,GraSegOpen( oPS ))
      oPreview:nPage := oPreview:nPage + 1
      ++oPreview:nPagePos
   ENDIF   
RETURN NIL

FUNCTION End_Doc(oPs)
   IF oPS = NIL
      oPS := oCurroPS
   ENDIF
   IF EMPTY(oPreview)
      oPS:device():EndDoc()
   ENDIF   
RETURN NIL

FUNCTION EndPrinter(oPS)
LOCAL nEvent, mp1, mp2 
LOCAL I,J
     // End spooling 
  IF EMPTY(oPreview)
     oPS:device():endDoc() 
     DestroyDevice( oPS )
  ELSE
     GraSegClose( oPS ) //End Current Page
     GraSegDrawMode( oPS, GRA_DM_DRAWANDRETAIN )
     oDlgPreview:DrawingArea:SetPointer(,XBPSTATIC_SYSICON_ARROW,XBPWINDOW_POINTERTYPE_SYSPOINTER)
     FOR I = 1 TO LEN(oDlgPreview:DrawingArea:ChildList())
        oDlgPreview:DrawingArea:ChildList()[I]:SetPointer(,XBPSTATIC_SYSICON_ARROW,XBPWINDOW_POINTERTYPE_SYSPOINTER)
        IF oDlgPreview:DrawingArea:ChildList()[I]:IsDerivedfrom("XbpPreview")
           oDlgPreview:DrawingArea:ChildList()[I]:SetPointer(,XBPSTATIC_SYSICON_ARROW,XBPWINDOW_POINTERTYPE_SYSPOINTER)
           oDlgPreview:DrawingArea:ChildList()[I]:oView:DrawingArea:SetPointer(,XBPSTATIC_SYSICON_ARROW,XBPWINDOW_POINTERTYPE_SYSPOINTER)
           FOR J = 1 TO LEN(oDlgPreview:DrawingArea:ChildList()[I]:ChildList())
              oDlgPreview:DrawingArea:ChildList()[I]:ChildList()[J]:SetPointer(,XBPSTATIC_SYSICON_ARROW,XBPWINDOW_POINTERTYPE_SYSPOINTER)
           NEXT J
       ENDIF
     NEXT I
     oPreview:nPagePos := 1
     oPreview:DrawPage()
     nEvent := 0
     DO WHILE oDlgPreview:Status() = XBP_STAT_CREATE
        nEvent := AppEvent( @mp1, @mp2, @oXbp )
        oXbp:handleEvent( nEvent, mp1, mp2 )
     ENDDO 
     oPreview := NIL
     IF !EMPTY(RtnScreen)
        SetAppFocus(RtnScreen:Assnum)
     ENDIF   
  ENDIF
  --ActiveReports 
RETURN NIL

