/***********************************
*     PROJECT :              
*        FILE :PrintForms.prg
*  Programmer :James Loughner
*  Created    :01/05/02
*  
*  Printer demo
*************************************/
 
#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "Appbrow.ch" 
#include "Dmlb.ch" 
#include "dll.ch"
#include "inkey.ch"

#include "prnsay.ch"    // tranlate PRNSAY command to function call

PROCEDURE Main()
LOCAL aPrint,oReg,oPS,cFont:="Times New Roman" ,NomPoint:=12,T := 4,L := 3  
LOCAL oBold,oItalic,oHead,oDemo                 
PUBLIC ActiveReports := 0  // track number of reports should be declared in main
   // note T is top margin L is left margian
   // StartPrinter perameters
   // cfont,nSizeFont,cPrinterObjectName,cIsLabel,lPreview,object_to_return_to
   // note  if cIsLabel is set to "Label" the printer will use the user defined
   //      form size in the printer object
   // if cPrinterObjectName is NIL the user will be asked for the printer
   aPrint  := StartPrinter(cFont,NomPoint,,,.T.)
   oReg  := aPrint[2]    // regular font
   oPS   := aPrint[1]    // presentation space

   oBold := XbpFont():new(oPS)              // Create XbpFont object 
   oBold:familyName := cFont // Describe font 
   oBold:nominalPointSize := NomPoint
   oBold:Bold := .T.
   oBold:create()                          // Create font 

   oItalic := XbpFont():new(oPS)              // Create XbpFont object 
   oItalic:familyName := cFont // Describe font 
   oItalic:nominalPointSize := NomPoint
   oItalic:Italic := .T.
   oItalic:create()                          // Create font 

   oHead := XbpFont():new(oPS)              // Create XbpFont object 
   oHead:familyName := cFont // Describe font 
   oHead:nominalPointSize := 20
   oHead:Italic := .T.
   oHead:create()                          // Create font   

   oCourier := XbpFont():new(oPS)              // Create XbpFont object 
   oCourier:familyName := "Courier New" // Describe font 
   oCourier:nominalPointSize := NomPoint
   oCourier:Italic := .F.
   oCourier:create()                          // Create font   


   SetFont(oReg)   // set defualt font
   SetReference(oReg) // set font to define a grid on the paper
   SetoPS(oPS)// set default presentation space  

   // We've set the fonts lets print somthing

   @ 0+T,  5+L PRNSAY  "This is the regular font indented 5 grid spaces" 
   PrnVar( { 1+T,  0+L}  ,  "This is the regular font no indent" )   // useing function
   PrnVar( { 6+T, 10+L}  , "Italic down 6 lines indent 10 spaces",,oItalic )
   // now for the heck of it lets print a line at lineno 4
   @ 4+T, 10+L PRNSAY "Line 4 Bold" FONT oBold


   // lets print some table headers    using the function
   PrnVar( {10+T,  3+L}  ,  "Data 1",,oBold ) 
   PrnVar( {10+T, 13+L}  ,  "Data 2",,oBold ) 
   PrnVar( {10+T, 23+L}  ,  "Data 3",,oBold ) 
   PrnVar( {10+T, 33+L}  ,  "Data 4",,oBold ) 
   PrnVar( {10+T, 43+L}  ,  "Data 5",,oBold ) 

   SetFont(oCourier)   // set  font  to  couruier
   FOR I = 1 to 15
      @ 10+T+I,  3+L PRNSAY STR(I,6)  
      @ 10+T+I, 13+L PRNSAY STR(I*10,6)  
      @ 10+T+I, 23+L PRNSAY STR(I*100,6)  
      @ 10+T+I, 33+L PRNSAY STR(I*3.14,6,2) 
      @ 10+T+I, 43+L PRNSAY -I  
   NEXT I
   
   //Start a second page
   Printer_Eject()
   PrnVar( {2+T, 15+L}  , "Second Page",,oHead )
   PrnVar( {10+T, 10+L}  , "Line 10",,oItalic )
   PrnVar( {20+T, 10+L}  , "Large Font Line 20",,oHead )
   
   EndPrinter(oPS)  // cleanup
   oBold:destroy()
   oItalic:destroy()
   oHead:destroy()
   oCourier:destroy()
RETURN 


